﻿Imports System.Runtime.CompilerServices
Public Module DataTableT

    ''' <summary> Überprüft, ob eine Column anhand ColumnName exisitert </summary>
    <Extension>
    Public Function colExists(dt As DataTable, colName As String) As Boolean
        For i = 0 To dt.Columns.Count - 1
            If dt.Columns(i).ColumnName.ToLower = colName.ToLower Then
                'Debug.WriteLine($"DGV:{dgv.Columns(i).Name.ToLower} | aus List: {colName.ToLower} | Return True")
                Return True
            End If
        Next
        Return False
    End Function

    ''' <summary> Erstellt eine neue DataTable mit den Spalten des DataGridView </summary>
    <Extension>
    Public Function NewDataTableWithColumnsFromDgv(dgv As DataGridView) As DataTable
        Dim newDt As New DataTable
        For Each col In dgv.ColumnsX
            newDt.Columns.Add(New DataColumn With {.ColumnName = col.Name, .Caption = col.HeaderText, .DataType = GetType(String)})
        Next
        Return newDt
    End Function

    ''' <summary> Erstellt eine neue Row mit Datengebundenen Items </summary>
    ''' <param name="dt"></param>
    ''' <param name="boundrow">DirectCast(dgvrow.DatabBoundItem, DataRowView).Row</param>
    ''' <returns>neue DataRow vorgefüllt mit datengebundenen Werten</returns>
    <Extension>
    Public Function FillRowWithDataBoundItems(dt As DataTable, boundrow As DataRow) As DataRow
        Return dt.Rows.Add(boundrow.ItemArray)
    End Function

End Module
