﻿Imports System.IO, System.Text.RegularExpressions
Public Class dlgFileRenamer

    'TODO: groß-/Kleinschreibung ignorieren - jedoch auch für den Replace
    'Dim match As Match = Regex.Match(Textbox1.text, "My house is cold", RegexOptions.IgnoreCase)
    'If match.Success Then
    'Msgbox(match.Value)
    'End If

#Region "Form"

    Private Sub frm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.KeyPreview = True
        Me.RegisterDlgKeyHandling
        WireUpRbtn()
    End Sub

    Private Sub frm_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        Select Case e.KeyCode
            Case Keys.F2 : getPathToTextBox(tbPath)
            Case Keys.F5 : run()
        End Select
    End Sub

#End Region 'Form

#Region "Clickables"

    Private Sub btn_Click(sender As Object, e As EventArgs) Handles btnSelectPath.Click,
                                                                    btnRun.Click
        Select Case True
            Case sender Is btnSelectPath : getPathToTextBox(tbPath)
            Case sender Is btnRun : run()
        End Select
    End Sub

#End Region

    Private Sub tb_Enter(sender As Object, e As EventArgs) Handles tbPath.Enter,
                                                                   tbSearch.Enter,
                                                                   tbReplace.Enter,
                                                                   tbAdd.Enter
        Dim tb = DirectCast(sender, TextBox)
        tb.SelectAll()
    End Sub

    Private Sub tb_MouseClick(sender As Object, e As MouseEventArgs) Handles tbPath.MouseClick,
                                                                             tbSearch.MouseClick,
                                                                             tbReplace.MouseClick,
                                                                             tbAdd.MouseClick
        Dim tb = DirectCast(sender, TextBox)
        tb.SelectAll()
    End Sub

    Private Sub run()
        Dim dir = tbPath.Text
        If Not Directory.Exists(dir) Then
            msgInformation($"Verzeichnis {dir} konnte nicht gefunden werden!")
            Return
        End If
        Me.Enabled = False
        Dim rtb = RichTextBox1
        Dim search = tbSearch.Text
        Dim replace = tbReplace.Text
        Dim add = tbAdd.Text
        Dim cntOK = 0
        Dim cntSkipped = 0
        rtb.Clear()
        For Each fi In Directory.GetFiles(dir, "*.*", If(cbSubdir.Checked, SearchOption.AllDirectories, SearchOption.TopDirectoryOnly))
            Dim fileName = Path.GetFileName(fi)
            If Not fileName.ToLower = "thumbs.db" Then 'thumbs.db überspringen 'TODO: Option für versteckte Dateien
                addRtxt(rtb, $"Datei: {fileName}")
                Select Case True
                    Case rbtnSeekAndReplace.Checked
                        If tbPath.Text = "" Then Return
                        If tbSearch.Text = "" Then Return
                        Select Case True
                            Case rbtnSnrLeft.Checked
                                If fileName Like $"{search}*" Then
                                    File.Move($"{fi}", $"{dir}\{fileName.Replace(search, replace)}")
                                    addRtxt(rtb, $"neuer Name: {fileName.Replace(search, replace)}")
                                    cntOK += 1
                                Else
                                    addRtxt(rtb, $"Datei entspricht nicht den Kriterien, wird übersprungen")
                                    cntSkipped += 1
                                End If
                            Case rbtnSnrMiddle.Checked
                                If fileName Like $"*{search}*" Then
                                    File.Move($"{fi}", $"{dir}\{fileName.Replace(search, replace)}")
                                    addRtxt(rtb, $"neuer Name: {fileName.Replace(search, replace)}")
                                    cntOK += 1
                                Else
                                    addRtxt(rtb, $"Datei entspricht nicht den Kriterien, wird übersprungen")
                                    cntSkipped += 1
                                End If
                            Case rbtnSnrRight.Checked
                                If fileName Like $"*{search}" Then
                                    'My.Computer.FileSystem.RenameFile($"{dir}\{fileName}", fileName.Replace(search, replace))
                                    File.Move($"{fi}", $"{dir}\{fileName.Replace(search, replace)}")
                                    addRtxt(rtb, $"neuer Name: {fileName.Replace(search, replace)}")
                                    cntOK += 1
                                Else
                                    addRtxt(rtb, $"Datei entspricht nicht den Kriterien, wird übersprungen")
                                    cntSkipped += 1
                                End If
                        End Select
                    Case rbtnAdd.Checked
                        If tbAdd.Text = "" Then Return
                        Select Case True
                            Case rbtnAddFirst.Checked
                                File.Move($"{fi}", $"{dir}\{add}{fileName}")
                                addRtxt(rtb, $"neuer Name: {add}{fileName}")
                                cntOK += 1
                            Case rbtnAddLast.Checked
                                Dim rawFilename = fileName.LastLeftCut("."c)
                                Dim fileExt = fileName.LastRightCut("."c)
                                File.Move($"{fi}", $"{dir}\{rawFilename}{add}{fileExt}")
                                addRtxt(rtb, $"neuer Name: {rawFilename}{add}{fileExt}")
                                cntOK += 1
                        End Select
                End Select
            End If
        Next
        msgInformation($"Abgeschlossen{Environment.NewLine}{cntOK} Dateien umbenannt{Environment.NewLine}{cntSkipped} Dateien übersprungen")
        Me.Enabled = True
    End Sub

    Private Sub WireUpRbtn()
        Dim kvps = New Dictionary(Of RadioButton, Control) From {
                                                                {rbtnSeekAndReplace, gbSeekAndReplace},
                                                                {rbtnAdd, gbAdd}
                                                                }
        For Each kvp In kvps
            kvp.Value.Enabled = kvp.Key.Checked ' initial den Wert setzen
            kvp.Value.DataBindings.Add("Enabled", kvp.Key, "Checked", False, DataSourceUpdateMode.Never) ' Control.Enabled an Checkbox.Checked binden
        Next
    End Sub

End Class