﻿''' <summary>
''' Contains flags specifying rules for ini-files.
''' </summary>
<Flags()> _
Public Enum IniFileFlags
    ''' <summary>
    ''' Specifies that the ini-file sticks to the default specification and does not treat any special rules.
    ''' </summary>
    [Default] = 0
    ''' <summary>
    ''' Specifies that the ini-file can contain multiple sections with the same name.
    ''' </summary>
    SupportsSectionNameRepetition = 1
    ''' <summary>
    ''' Specifies that within a section there can exist multiple key-value pairs with the same key.
    ''' </summary>
    SupportsKeyValuePairKeyRepetition = 2
    ''' <summary>
    ''' Specifies a case insensitive search for keys and section names.
    ''' </summary>
    ''' <remarks>A custom search can be implemented using the virtual methods for collection initialization.</remarks>
    CaseInsensitive = 4
End Enum