﻿Imports System.Runtime.CompilerServices
Public Module MessageBoxes

	''' <summary>zeigt eine Messagebox, wenn die gefilterte Bindingsource keine Elemente enthält</summary>
	<Extension>
	Public Sub MsgNoEntry(bs As BindingSource)
		If bs.Count = 0 Then msgInformation("keine Einträge")
	End Sub

	Public Sub msgDeleteDenied()
		msgInformation("Löschen nicht möglich!")
	End Sub

	Public Function msgOkCancel(Nachricht As String, Titel As String) As DialogResult
		Return MessageBox.Show(Nachricht, Titel, MessageBoxButtons.OKCancel, MessageBoxIcon.Information, Nothing) ', MessageBoxOptions.ServiceNotification)
	End Function
	Public Sub msgInformation(Nachricht As String)
		MessageBox.Show(Nachricht, "Information", MessageBoxButtons.OK, MessageBoxIcon.Information, Nothing) ', MessageBoxOptions.ServiceNotification)
	End Sub

	Public Sub Msg(ParamArray items As Object())
		MessageBox.Show(String.Concat(items))
	End Sub

	Public Sub msgEx(ex As Exception, Optional customInfo As String = Nothing)
		If customInfo Is Nothing Then
			MessageBox.Show(ex.Message, "Ausnahmefehler", MessageBoxButtons.OK, MessageBoxIcon.Error, Nothing) ', MessageBoxOptions.ServiceNotification)
		Else
			MessageBox.Show($"{ex.Message}{Environment.NewLine}{customInfo}", "Ausnahmefehler", MessageBoxButtons.OK, MessageBoxIcon.Error, Nothing) ', MessageBoxOptions.ServiceNotification)
		End If
	End Sub

	Public Sub msgExclamation(Nachricht As String)
		MessageBox.Show(Nachricht, "Wichtige Info", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, Nothing) ', MessageBoxOptions.ServiceNotification)
	End Sub

	Public Sub msgError(Nachricht As String)
		MessageBox.Show(Nachricht, "FEHLER", MessageBoxButtons.OK, MessageBoxIcon.Error, Nothing) ', MessageBoxOptions.ServiceNotification)
	End Sub

	Public Function msgQuestionWarning(Nachricht As String) As DialogResult
		Return MessageBox.Show(Nachricht, "Warnung", MessageBoxButtons.YesNo, MessageBoxIcon.Warning, Nothing) ', MessageBoxOptions.ServiceNotification)
	End Function

	Public Function msgQuestionInfo(Nachricht As String) As DialogResult
		Return MessageBox.Show(Nachricht, "Frage", MessageBoxButtons.YesNo, MessageBoxIcon.Question, Nothing) ', MessageBoxOptions.ServiceNotification)
	End Function
End Module
