﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.ComponentModel

Namespace Global.System.Threading

    Public Module ThreadingT

        Public Class WaitDlg : Implements IDisposable
            Private _waitDlg As Form

            Public Sub New(dlg As Form)
                _waitDlg = dlg
                Dim thr As New Thread(New ThreadStart(AddressOf workerThread))
                With thr
                    .IsBackground = True
                    .SetApartmentState(ApartmentState.STA)
                    .Start()
                End With
            End Sub

            Public Sub Dispose() Implements IDisposable.Dispose
                'Dim sw As New Stopwatch
                'sw.Start()
                'If Not _waitDlg.IsHandleCreated Then
                '    Do Until _waitDlg.IsHandleCreated
                '        If sw.ElapsedMilliseconds > 5000 Then Throw New Exception("FensterHandle konnte nicht erstellt werden!")
                '    Loop
                'End If
                'sw.Stop()
                If Not _waitDlg.IsHandleCreated Then Thread.Sleep(250)
                _waitDlg.Invoke(New MethodInvoker(AddressOf stopThread))
            End Sub

            Private Sub stopThread()
                _waitDlg.Close()
            End Sub

            Private Sub workerThread()
                With _waitDlg
                    .TopMost = True
                End With
                Application.Run(_waitDlg)
            End Sub

        End Class

        ''' <summary>Returnt einen asynchronen Dialog</summary>
        Public Function CreateAsyncDlg(Of T As {Form, New})(Title As String) As T
            Dim blocker As New Threading.ManualResetEventSlim
            Dim dlg As New T
            dlg.Text = Title
            Dim th As New Thread(Sub()
                                     AddHandler dlg.Shown, Sub(s, e) blocker.Set()
                                     dlg.ShowDialog()
                                     dlg.Dispose()
                                     blocker.Dispose()
                                 End Sub)
            th.Priority = Threading.ThreadPriority.Highest
            th.Start()
            blocker.Wait()
            Return dlg
        End Function

    End Module

End Namespace
