﻿Public Class frmMain

    Public Sub New()
        InitializeComponent()
        Me.KeyPreview = True
        App.PersistanceModeXml = True
        Select Case App.PersistanceModeXml
            Case True : Dts.Register(Me, False).DataFile(App.DtsXmlFile).Fill
            Case False : Dts.Register(Me, False) : Dts.FillAll
        End Select
        FillTree()
        AppSetting.InitAppSetting()
        CreateDefaultDataIfNotExist()
    End Sub

    Private Sub CreateDefaultDataIfNotExist()
        Dim anreden = {"<keine Angabe>", "Frau", "Herr"}
        For Each str In anreden
            If Not Dts.Anrede.Any(Function(x) x.Text = str) Then Dts.Anrede.AddAnredeRow(str, If(str Like "<keine*", False, True))
        Next
        Dts.SaveDts()
    End Sub

    Private Sub ts_Click(sender As Object, e As EventArgs) Handles tsQuit.Click,
                                                                   tsSave.Click
        Select Case True
            Case sender Is tsQuit : Me.Close()
            Case sender Is tsSave : Dts.SaveDts() : msgInformation("Daten gespeichert")
        End Select
    End Sub

    Private Sub FillTree()
        tvMain.Nodes.Clear()
        tvMain.Nodes.Add("anreden", "Anreden")
        tvMain.Nodes.Add("appsettings", "App-Settings")
        tvMain.Nodes.Add("person", "Personen")
    End Sub

    Private Sub tvMain_NodeMouseDoubleClick(sender As Object, e As TreeNodeMouseClickEventArgs) Handles tvMain.NodeMouseDoubleClick
        RunSelectedTreeNode(e.Node.Name)
    End Sub

    Private Sub tvMain_KeyDown(sender As Object, e As KeyEventArgs) Handles tvMain.KeyDown
        Dim tv = DirectCast(sender, TreeView)
        Select Case e.KeyCode
            Case Keys.Enter : If tv.SelectedNode IsNot Nothing Then RunSelectedTreeNode(tv.SelectedNode.Name)
        End Select
    End Sub

    Private Sub RunSelectedTreeNode(selectedNode As String)
        Select Case selectedNode
            Case "anreden" : ShowMdiLocal(frmAnrede)
            Case "appsettings" : ShowMdiLocal(frmAppSettings)
            Case "person" : ShowMdiLocal(frmPerson)
        End Select
    End Sub

End Class
